
## Purpose

This Git Repository intends to represent environments in Docker Compose.  All environments are effectively a derivative of other environments.  The original environment is the environment represented by the `base` branch.  All derivative environments are represented by other branches.  Those branches are named in the format `{core}.{parent}`.

## Backup & Restore

### Backup

A previously run Docker Compose environment is required in order to perform a backup.  The Docker Compose resultant containers may or may not use volumes for persistence.  It is assumed that the Docker Compose environment is stopped at the time of the backup.

```sh
docker-compose stop
scripts/backup-data.sh
```

This will result in the creation or replacement of the `data` directory.  This will hold all the resources required for a subsequent *Restore* execution.

### Restore

A clean Docker Compose environment is **not** required in order to perform a restore.  The script will destory any existing data that may exist at the time of execution.  It will also stop and remove any existing Docker containers.  The Docker Compose resultant containers may or may not use volumes for persistence.

```sh
scripts/restore-data.sh
```
